@echo off
REM NT/2000/XP only

REM Scans for security hole created by FrontPage extensions
REM when the FTP and FrontPage Web home directory is the same
REM (_vti_pvt directory becomes writeable to the world)

REM Without parameters attempts to connect to an FTP server on each local IP address
REM Otherwise scans the IP address specified in %1
REM If the IP address specified in %1 ends in .0, then the
REM entire Class C subnet will be scanned
REM Note that to speed up subnet scanning, we first ping each target IP
REM and if it doesn't respond within 100 ms, we skip it
REM If doing this across WAN or something like that set the environment variable
REM PING_TIMEOUT to the desired Timeout in milliseconds.

REM If any Writeable FTP Hosts are found, the ERRORLEVEL is set to 1, otherwise 0.

REM Requires IPs.bat which can be in the current directory, the path, the same
REM directory as this batch file or in the path specified in the environment variable PROG_SOURCE

REM You can also override the ftp path scanned for writeability (_vti_pvt by default) by specifying
REM it in the S4F_PATH environment variable.  Use / for the ftp root.

SETLOCAL

set S4F_FOUND=0
set S4F_SUBNET=
if "%S4F_PATH%"=="" set S4F_PATH=_vti_pvt

if "%PROG_SOURCE%"=="" set PROG_SOURCE=%~dp0
if not exist %PROG_SOURCE%IPs.bat set PROG_SOURCE=%PROG_SOURCE%\
if not exist %PROG_SOURCE%IPs.bat set PROG_SOURCE=

if "%PING_TIMEOUT%"=="" set PING_TIMEOUT=100

echo anonymous>%temp%\scan4ftp.txt
echo support@am.net>>%temp%\scan4ftp.txt
echo cd %S4F_PATH%>>%temp%\scan4ftp.txt
echo put %temp%\scan4ftp.txt>>%temp%\scan4ftp.txt
echo get scan4ftp.txt %temp%\scan4ftp.dat>>%temp%\scan4ftp.txt
echo delete scan4ftp.txt>>%temp%\scan4ftp.txt
echo bye>>%temp%\scan4ftp.txt

if "%1"=="" goto local
FOR /F "tokens=1,2,3,4 delims=." %%A in ("%1") DO IF "%%D"=="0" set S4F_SUBNET=%%A.%%B.%%C
IF DEFINED S4F_SUBNET goto subnet

call :ftp %1
goto done

:local
for /f %%I IN ('%PROG_SOURCE%IPs') DO call :ftp %%I
goto done

:subnet
FOR /L %%I IN (1,1,254) DO ping -n 1 -w %PING_TIMEOUT% %S4F_SUBNET%.%%I |find /C /I "timed out">nul&IF ERRORLEVEL 1 call :ftp %S4F_SUBNET%.%%I
goto done

:ftp
echo Checking %1 ...
del %temp%\scan4ftp.dat 2>nul
rem Win2K and later support -n -A (for anonymous login) but NT4 does not support -A!
ftp -v -i -s:%temp%\scan4ftp.txt %1 >nul 2>&1
if not exist %temp%\scan4ftp.dat goto :EOF
rem 0-byte %temp%\scan4ftp.dat still gets created if could not login!
find %temp%\scan4ftp.dat "anonymous" >nul
IF NOT ERRORLEVEL 1 set S4F_FOUND=1 &echo     Writeable FTP Host found: %1
goto :EOF

:done
del %temp%\scan4ftp.txt 2>nul
del %temp%\scan4ftp.dat 2>nul

REM Exit with errorlevel of 1 if one or more Writeable FTP Hosts were found:
echo %S4F_FOUND%|find /C "0" >nul

ENDLOCAL