@echo off
REM Outlook 2000/2002/2003 MAPI Profile Import/Export multi-platform utility
REM Older versions and Exchange Client are currently NOT supported

REM Import Mode (no switches or parameters)
REM ---------------------------------------
REM Generates the MAPI profile by first importing a registry export
REM called outprf9x.reg or outprfnt.reg depending on platform
REM then parsing a template.prf to be customized for the currently logged in user
REM and then creating/modifying the existing profile with modprof.exe for Outlook 2000
REM or for Outlook 2002/2003 by setting up Outlook to import the modified outlook.prf
REM file upon next execution of Outlook - the outlook.prf file is permanently stored in
REM the user's profile directory in NT/2000/XP or in %HOMEDRIVE% (I:) under Win9x

REM The imported profile will have the same name as the originally exported profile
REM and it becomes the Default profile.

REM Export Mode (genprof /e [Profile Name])
REM -----------------------------------------
REM 'genprof /e' will export the current Default profile (or "Microsoft Outlook" if no Default)
REM to c:\outprf9x.reg or c:\outprfnt.reg depending on platform
REM Win2000/XP-format registry export files are converted to ANSI REGEDIT4 format
REM so that they can be used under Windows NT 4.0 as well (it also makes it half the size!)

REM Alternatively, you can specify the name of the profile to export after the switch,
REM However, do NOT enclose the profile name in "" even if it has spaces!

if !%1==! goto import
if %1==export goto export
if %1==-export goto export
if %1==/export goto export
if %1==Export goto export
if %1==-Export goto export
if %1==/Export goto export
if %1==EXPORT goto export
if %1==-EXPORT goto export
if %1==/EXPORT goto export
if %1==E goto export
if %1==-E goto export
if %1==/E goto export
if %1==e goto export
if %1==-e goto export
if %1==/e goto export
goto import

:export
echo Exporting Profile Registry ...
set PRFFILE=outprf9x.reg
set PRFREGKEY=HKEY_CURRENT_USER\Software\Microsoft\Windows Messaging Subsystem\Profiles
if !%OS%==!Windows_NT set PRF_START_TITLE=""
if NOT !%OS%==!Windows_NT set PRF_START_TITLE=
if !%OS%==!Windows_NT set PRFFILE=outprfnt.reg
if !%OS%==!Windows_NT set PRFREGKEY=HKEY_CURRENT_USER\Software\Microsoft\Windows NT\CurrentVersion\Windows Messaging Subsystem\Profiles

if "%2"=="" goto getdefault
set DefaultMAPIProfile=%2
if NOT "%3"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %3
if NOT "%4"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %4
if NOT "%5"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %5
if NOT "%6"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %6
if NOT "%7"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %7
if NOT "%8"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %8
if NOT "%9"=="" set DefaultMAPIProfile=%DefaultMAPIProfile% %9
goto expreg

:getdefault
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
%0\..\kix32 %0\..\reg2var.scr $Output=%temp%\tmpset.bat $Var=DefaultMAPIProfile $Key="%PRFREGKEY%" $Value=DefaultProfile
if exist %temp%\tmpset.bat call %temp%\tmpset.bat
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
if "%DefaultMAPIProfile%"=="" set DefaultMAPIProfile=Microsoft Outlook

:expreg
echo REGEDIT4>c:\%PRFFILE%
echo.>>c:\%PRFFILE%
echo [%PRFREGKEY%]>>c:\%PRFFILE%
echo "DefaultProfile"="%DefaultMAPIProfile%">>c:\%PRFFILE%
echo.>>c:\%PRFFILE%

start /wait %PRF_START_TITLE% regedit /e c:\prftmp.reg "%PRFREGKEY%\%DefaultMAPIProfile%"

type c:\prftmp.reg|find /V "REGEDIT4"|find /V "Windows Registry Editor Version 5.00"|find /V "Windows Registry Editor Version 5.1"|find /V "Windows Registry Editor Version 5.2">>c:\%PRFFILE%
del c:\prftmp.reg
goto end

:import
set COPYCMD=/y
if "%HOMEDRIVE%"=="" set HOMEDRIVE=I:
if !%OS%==!Windows_NT set PRF_START_TITLE=""
if NOT !%OS%==!Windows_NT set PRF_START_TITLE=
if !%OS%==!Windows_NT set PRFFILE=outprfnt.reg
if NOT !%OS%==!Windows_NT set PRFFILE=outprf9x.reg
if !%OS%==!Windows_NT set PRFREGKEY=HKEY_CURRENT_USER\Software\Microsoft\Windows NT\CurrentVersion\Windows Messaging Subsystem\Profiles
if NOT !%OS%==!Windows_NT set PRFREGKEY=HKEY_CURRENT_USER\Software\Microsoft\Windows Messaging Subsystem\Profiles

echo Setting up for Profile Customization ...
REM Set up temp directory, add it to the path and copy needed files to it:
if "%temp%"=="" set temp=c:\temp
REM First line below is for NT4, second for Win9x, third for W2K:
if "%~0"=="" %0\..\mmd "%temp%\prftmp"
if "%~0"=="~0" %0\..\mmd "%temp%\prftmp"
if NOT "%~0"=="" if NOT "%~0"=="~0" %~0\..\mmd "%temp%\prftmp"
set PRFTMPPATH=%PATH%
set PATH=%temp%\prftmp;%PATH%
copy %0\..\template.prf %temp%\prftmp
copy %0\..\listvars.bat %temp%\prftmp
copy %0\..\replace.bat %temp%\prftmp
copy %0\..\mt.exe %temp%\prftmp
copy %0\..\sortx.exe %temp%\prftmp
copy %0\..\%PRFFILE% %temp%\prftmp
copy %0\..\modprof.exe %temp%\prftmp

echo Importing Profile Registry ...
start /wait regedit /s %temp%\prftmp\%PRFFILE%

echo Customizing the Profile Configuration File ...

REM Get the Profile Name and set it in the template.prf file
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
%0\..\kix32 %0\..\reg2var.scr $Output=%temp%\tmpset.bat $Var=DefaultMAPIProfile $Key="%PRFREGKEY%" $Value=DefaultProfile
if exist %temp%\tmpset.bat call %temp%\tmpset.bat
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
if "%DefaultMAPIProfile%"=="" set DefaultMAPIProfile=Microsoft Outlook
%0\..\kix32 %0\..\setini.scr $File=%temp%\prftmp\template.prf $Section=General $Key=ProfileName $Value="%DefaultMAPIProfile%"

REM Replace the variables in template.prf with the current user's info:
%0\..\kix32 %0\..\varsub.scr $File=%temp%\prftmp\template.prf $Delim=$

echo Modifying the Profile ...
REM Get Outlook version if OUTVER variable not yet defined (it should be in settings.bat!)
if NOT "%OUTVER%"=="" goto skipOutVer
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
%0\..\kix32 %0\..\OfficeVars.scr $Output=%temp%\prftmp\OfcVars.bat 
type %temp%\prftmp\OfcVars.bat|find /I "set OUTVER=">%temp%\tmpset.bat
if exist %temp%\tmpset.bat call %temp%\tmpset.bat
if exist %temp%\tmpset.bat del %temp%\tmpset.bat
IF "%OUTVER%"=="" set OUTVER=NO
:skipOutVer

IF %OUTVER%==NO goto Cleanup

REM Modify the profile using modprof.exe if Outlook 2000:
IF %OUTVER%==O2K start /wait %temp%\prftmp\modprof -P %temp%\prftmp\template.prf
IF %OUTVER%==O2K goto Cleanup

REM Launch Outlook 2002/2003 with the import of the .prf file:
REM *** This is currently disabled *** start /wait outlook.exe /importprf %temp%\prftmp\template.prf

REM Set a registry key to trigger Outlook to import the PRF file when Outlook 2002/2003 starts up
if NOT !%OS%==!Windows_NT set PRF_TARGETDIR=%HOMEDRIVE%
if NOT !%OS%==!Windows_NT set REG_TARGETDIR=%HOMEDRIVE%
if !%OS%==!Windows_NT set PRF_TARGETDIR=%USERPROFILE%
if !%OS%==!Windows_NT set REG_TARGETDIR=%USERPROFILE:\=\\%
echo REGEDIT4>%temp%\prftmp\prftmp.reg
echo.>>%temp%\prftmp\prftmp.reg
if %OUTVER%==OXP echo [HKEY_CURRENT_USER\Software\Microsoft\Office\10.0\Outlook\Setup]>>%temp%\prftmp\prftmp.reg
if %OUTVER%==O11 echo [HKEY_CURRENT_USER\Software\Microsoft\Office\11.0\Outlook\Setup]>>%temp%\prftmp\prftmp.reg
echo "ImportPRF"="%REG_TARGETDIR%\\outlook.prf">>%temp%\prftmp\prftmp.reg
echo.>>%temp%\prftmp\prftmp.reg
regedit /s %temp%\prftmp\prftmp.reg
copy %temp%\prftmp\template.prf "%PRF_TARGETDIR%\outlook.prf"
set PRF_TARGETDIR=
set REG_TARGETDIR=

:Cleanup
echo Cleaning up ...
echo Y|del "%temp%\prftmp\*.*"
rmdir "%temp%\prftmp"
set PATH=%PRFTMPPATH%
set PRFTMPPATH=
echo Done!

:end
set PRFFILE=
set PRFREGKEY=
set PRF_START_TITLE=
